﻿package game{
	import flash.display.Sprite;
	import flash.utils.Timer;
	import flash.utils.Dictionary;
	import flash.events.*;
	import flash.ui.Keyboard;
	public class MainGame extends Sprite {
		var myShip:MyShip;
		var mainTimer:Timer;
		private var _enemyList:Dictionary;
		private var _stageData:StageData;
		private var _roundCount:int;
		private var _nextRoundCount:int;
		
		//コンストラクタ
		public function MainGame() {
			startGame();
		}
		
		/*ここからゲーム開始処理*/
		public function startGame() {
			myShip = new MyShip(150, 300, 20);
			addChild(myShip.body);
			mainTimer = new Timer(40,0);
			mainTimer.addEventListener(TimerEvent.TIMER, onMainTimer);
			_enemyList = new Dictionary();
			addEventListener(Event.ENTER_FRAME, drawGame);
			stage.addEventListener(KeyboardEvent.KEY_DOWN,onKey);
			stage.addEventListener(KeyboardEvent.KEY_UP,onKey);
			_stageData = new StageData();
			_stageData.addEventListener("parse_complete", onStageLoad);
			loadStage("stage1Data.txt");
		}
		function loadStage(fileName:String):void {
			_stageData.load(fileName);
		}
		private function onStageLoad(event:Event):void {
			_roundCount = 0;
			executeCommand();
			mainTimer.start();
		}

		/*ここから移動処理*/
		private function onMainTimer(event:TimerEvent):void {
			myShip.action();
			for each (var enemy:Unit in _enemyList) {
				enemy.action();
			}
			if (_roundCount++ > _nextRoundCount) {
				executeCommand();
				_roundCount = 0;
			}
		}
		private function executeCommand():void {
			var command:Array = _stageData.getNext();
			switch (command[0]) {
				case "wait" :
					_nextRoundCount = int(command[1]);
					break;
				case "end" :
					clearStage();
					break;
				default :
					var useClass:Class = getUseClass(command[0]);
					addEnemy(useClass,int(command[1]),int(command[2]));
					executeCommand();
			}
		}
		private function getUseClass(className:String):Class {
			switch (className) {
				case "EnemyA" :
					return EnemyA;
				case "EnemyB" :
					return EnemyB;
				case "EnemyC" :
					return EnemyC;
				default :
					return EnemyA;
			}
		}

		private function drawGame(event:Event):void {
			myShip.draw();
			for each (var enemy:Unit in _enemyList) {
				enemy.draw();
			}
		}
		
		private function onKey(event:KeyboardEvent) {
			switch (event.keyCode) {
				case Keyboard.RIGHT :
				case Keyboard.LEFT :
					var flag:Boolean = (event.type == KeyboardEvent.KEY_DOWN);
					myShip.setKeyFlag(event.keyCode, flag);
					break;
			}
		}
		
		function addEnemy(unitClass:Class, newX:int, newY:int) {
			var enemy:Unit;
			if (unitClass == EnemyC) {
				enemy = new unitClass(myShip, newX, newY);
			} else {
				enemy = new unitClass(newX, newY);
			}
			addChild(enemy.body);
			enemy.draw();
			_enemyList[enemy] = enemy;
		}

		function removeEnemy(enemy:Unit) {
			removeChild(enemy.body);
			delete _enemyList[enemy];
		}
		
		function clearStage():void {
			trace("ステージが終了しました");
			mainTimer.stop();
		}
	}
}